/* A Bison parser, made from DssParser.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	PLUS	257
# define	MINUS	258
# define	MULT	259
# define	DIV	260
# define	EXPO	261
# define	MODULO	262
# define	ANDIF	263
# define	ORIF	264
# define	NOT	265
# define	BLOCKFILTER1	266
# define	BLOCKFILTER2	267
# define	IN	268
# define	RELOP	269
# define	AND	270
# define	OR	271
# define	XOR	272
# define	LSHIFT	273
# define	RSHIFT	274
# define	BITCOMPL	275
# define	TRUECONST	276
# define	FALSECONST	277
# define	RPOINT	278
# define	RLINE	279
# define	RCIRCLE	280
# define	RRING	281
# define	RELLIPSE	282
# define	RELLIPSERING	283
# define	RBOX	284
# define	RRECTANGLE	285
# define	RPOLYGON	286
# define	RSECTOR	287
# define	RDIAMOND	288
# define	BLOCK	289
# define	NUMBER	290
# define	AXISNAME	291
# define	AFUNC1	292
# define	AFUNC2	293

#line 1 "DssParser.y"

  //---------------------------------------------------------------------------
  //
  //                     XMM Science Analysis System (SAS)
  //                   (c) 1997-2010 European Space Agency
  //
  //---------------------------------------------------------------------------
  //
  //  DssGrammar.y --- grammar for DSS expressions
  //
  //  DESCRIPTION:
  //      This is a yacc/bison input file which defines the grammar of
  //      DSS-compliant selection expressions.
  //
  //  CHANGE HISTORY:
  //      UL, 1999-11-16: 1.0.0: - first version
  //      UL, 1999-12-17: 1.1.0: - brought in line with selectlib-4.23
  //                               (Region->GeoRegion)
  //
  //  AUTHOR:
  //      U. Lammers (UL), Tue Nov 16 10:35:01 MET 1999
  //
  //  $Header: /sasbuild/repositories/sasdev/sas/packages/dsslib/src/build/DssParser.cc,v 1.2 2003/12/05 16:20:09 aibarra Exp $
  ///

  //#include <values.h> // This may make Debian Linux happy
#include<cfloat>
#include <cmath>
#include <climits>
#include <string>
#include <cstdio>

#include "basicdefs.h"
#include "Dal.h"
#include "DssBuilder.h"

#define YYDEBUG 1

#define yylex       dsslex
  extern int dsslex();        //  this is the name of the lexer function
                              //  that flex generates with the -Pdss
                              //  option; we do need a distinct name
                              //  in order to avoid name clashes with
                              //  other lexers in the SAS

  namespace DssParser {

    extern void yyerror(char *);    //  The locally added functions in the
                                    //  lexer are in a namespace DssParser

    enum RelOp {LtOpT=1, LeOpT, GtOpT, GeOpT, EqOpT, NeOpT};
    
    extern const Table * yyFilteredTable;

    
#line 57 "DssParser.y"
#ifndef YYSTYPE
typedef union {
    double                  yNumber;
    std::string                  *yBlockSpec;
    std::string                  *yAxisName;
    double                  (*yFunc1)(double);
    double                  (*yFunc2)(double, double);
    DRange                  *yRange;
    DRangeList              *yRangeList;
    std::vector<float>           *yPointList;
    RelOp                   yRelOp;
    DSfilter                *yDSfilter;
  } yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		396
#define	YYFLAG		-32768
#define	YYNTBASE	46

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 293 ? yytranslate[x] : 57)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      40,    41,     2,     2,    42,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    43,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    44,     2,    45,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     2,     6,     9,    13,    17,    19,    21,    25,
      27,    31,    35,    42,    49,    60,    65,    74,    89,   102,
     106,   110,   112,   116,   120,   121,   129,   142,   157,   174,
     197,   214,   231,   248,   263,   272,   281,   292,   305,   324,
     337,   350,   363,   374,   379,   385,   389,   393,   395,   399,
     403,   407,   411,   415,   419,   423,   427,   431,   435,   439,
     442,   447,   454,   457,   461,   463,   465,   469,   473,   477,
     481,   483,   487,   490,   495,   500,   505,   510,   513,   518,
     523,   528,   533,   537,   543,   549,   555
};
static const short yyrhs[] =
{
      47,     0,    40,    47,    41,     0,    11,    47,     0,    47,
       9,    47,     0,    47,    10,    47,     0,    49,     0,    37,
       0,    40,    37,    41,     0,    22,     0,    48,    14,    54,
       0,    50,    15,    36,     0,    48,    14,    12,    40,    35,
      41,     0,    12,    40,    35,    42,    48,    41,     0,    40,
      48,    42,    48,    41,    14,    13,    40,    35,    41,     0,
      13,    40,    35,    41,     0,    13,    40,    35,    42,    48,
      42,    48,    41,     0,    40,    48,    42,    48,    41,    14,
      13,    40,    35,    42,    55,    42,    55,    41,     0,    13,
      40,    35,    42,    55,    42,    55,    42,    48,    42,    48,
      41,     0,    48,    15,    55,     0,    55,    15,    48,     0,
      51,     0,    48,    16,    55,     0,    40,    50,    41,     0,
       0,    40,    48,    42,    48,    41,    14,    52,     0,    26,
      40,    55,    42,    55,    42,    55,    42,    48,    42,    48,
      41,     0,    27,    40,    55,    42,    55,    42,    55,    42,
      55,    42,    48,    42,    48,    41,     0,    28,    40,    55,
      42,    55,    42,    55,    42,    55,    42,    55,    42,    48,
      42,    48,    41,     0,    29,    40,    55,    42,    55,    42,
      55,    42,    55,    42,    55,    42,    55,    42,    55,    42,
      55,    42,    48,    42,    48,    41,     0,    30,    40,    55,
      42,    55,    42,    55,    42,    55,    42,    55,    42,    48,
      42,    48,    41,     0,    31,    40,    55,    42,    55,    42,
      55,    42,    55,    42,    55,    42,    48,    42,    48,    41,
       0,    34,    40,    55,    42,    55,    42,    55,    42,    55,
      42,    55,    42,    48,    42,    48,    41,     0,    33,    40,
      55,    42,    55,    42,    55,    42,    55,    42,    48,    42,
      48,    41,     0,    32,    40,    53,    42,    48,    42,    48,
      41,     0,    26,    40,    55,    42,    55,    42,    55,    41,
       0,    27,    40,    55,    42,    55,    42,    55,    42,    55,
      41,     0,    28,    40,    55,    42,    55,    42,    55,    42,
      55,    42,    55,    41,     0,    29,    40,    55,    42,    55,
      42,    55,    42,    55,    42,    55,    42,    55,    42,    55,
      42,    55,    41,     0,    30,    40,    55,    42,    55,    42,
      55,    42,    55,    42,    55,    41,     0,    31,    40,    55,
      42,    55,    42,    55,    42,    55,    42,    55,    41,     0,
      34,    40,    55,    42,    55,    42,    55,    42,    55,    42,
      55,    41,     0,    33,    40,    55,    42,    55,    42,    55,
      42,    55,    41,     0,    32,    40,    53,    41,     0,    53,
      42,    55,    42,    55,     0,    55,    42,    55,     0,    54,
      42,    56,     0,    56,     0,    55,     3,    55,     0,    55,
       4,    55,     0,    55,     5,    55,     0,    55,     6,    55,
       0,    55,     8,    55,     0,    55,     7,    55,     0,    55,
      16,    55,     0,    55,    17,    55,     0,    55,    18,    55,
       0,    55,    19,    55,     0,    55,    20,    55,     0,    21,
      55,     0,    38,    40,    55,    41,     0,    39,    40,    55,
      42,    55,    41,     0,     4,    55,     0,    40,    55,    41,
       0,    36,     0,    43,     0,    44,    43,    45,     0,    40,
      43,    45,     0,    44,    43,    41,     0,    40,    43,    41,
       0,    55,     0,    44,    55,    45,     0,    55,    43,     0,
      44,    55,    43,    45,     0,    44,    55,    43,    41,     0,
      40,    55,    43,    45,     0,    40,    55,    43,    41,     0,
      43,    55,     0,    44,    43,    55,    45,     0,    44,    43,
      55,    41,     0,    40,    43,    55,    45,     0,    40,    43,
      55,    41,     0,    55,    43,    55,     0,    44,    55,    43,
      55,    45,     0,    40,    55,    43,    55,    45,     0,    44,
      55,    43,    55,    41,     0,    40,    55,    43,    55,    41,
       0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   104,   107,   108,   109,   110,   111,   114,   115,   118,
     119,   131,   140,   152,   164,   173,   178,   187,   201,   215,
     257,   298,   310,   327,   331,   331,   334,   339,   344,   349,
     354,   359,   364,   369,   374,   382,   385,   388,   391,   394,
     397,   400,   403,   406,   412,   417,   425,   430,   436,   437,
     438,   439,   446,   453,   461,   462,   463,   464,   465,   466,
     467,   468,   470,   471,   472,   475,   477,   479,   481,   483,
     485,   486,   487,   489,   491,   493,   495,   497,   499,   501,
     503,   505,   507,   508,   509,   511,   513
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "PLUS", "MINUS", "MULT", "DIV", "EXPO", 
  "MODULO", "ANDIF", "ORIF", "NOT", "BLOCKFILTER1", "BLOCKFILTER2", "IN", 
  "RELOP", "AND", "OR", "XOR", "LSHIFT", "RSHIFT", "BITCOMPL", 
  "TRUECONST", "FALSECONST", "RPOINT", "RLINE", "RCIRCLE", "RRING", 
  "RELLIPSE", "RELLIPSERING", "RBOX", "RRECTANGLE", "RPOLYGON", "RSECTOR", 
  "RDIAMOND", "BLOCK", "NUMBER", "AXISNAME", "AFUNC1", "AFUNC2", "'('", 
  "')'", "','", "':'", "'['", "']'", "dssexpr", "dss", "axisname", 
  "filter", "bitmask", "regionfilter", "regiontype", "pointlist", 
  "intervallist", "arith", "intervalspec", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    46,    47,    47,    47,    47,    47,    48,    48,    49,
      49,    49,    49,    49,    49,    49,    49,    49,    49,    49,
      49,    49,    50,    50,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    53,    53,    54,    54,    55,    55,
      55,    55,    55,    55,    55,    55,    55,    55,    55,    55,
      55,    55,    55,    55,    55,    56,    56,    56,    56,    56,
      56,    56,    56,    56,    56,    56,    56,    56,    56,    56,
      56,    56,    56,    56,    56,    56,    56
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     1,     3,     2,     3,     3,     1,     1,     3,     1,
       3,     3,     6,     6,    10,     4,     8,    14,    12,     3,
       3,     1,     3,     3,     0,     7,    12,    14,    16,    22,
      16,    16,    16,    14,     8,     8,    10,    12,    18,    12,
      12,    12,    10,     4,     5,     3,     3,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       4,     6,     2,     3,     1,     1,     3,     3,     3,     3,
       1,     3,     2,     4,     4,     4,     4,     2,     4,     4,
       4,     4,     3,     5,     5,     5,     5
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
      24,     0,    24,     0,     0,     0,     9,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    64,     7,     0,     0,
      24,     1,     0,     6,     0,    21,     0,     0,    62,     3,
       0,     0,    59,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     7,     0,     0,     0,     0,    24,
      24,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     8,     2,     0,    23,    63,     4,     5,     0,
       0,    65,     0,    10,    70,    47,    19,    22,    11,    48,
      49,    50,    51,    53,    52,     0,    20,    54,    55,    56,
      57,    58,     0,    15,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    60,     0,     0,     0,     0,
       0,    77,     0,     0,     0,    72,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
       0,     0,     0,     0,     0,    69,    67,     0,     0,    68,
      66,     0,     0,    71,    46,    82,    13,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    61,
       0,    12,    81,    80,    76,    75,     0,    79,    78,    74,
      73,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    44,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    25,    86,    84,    85,    83,    16,
       0,     0,     0,     0,     0,     0,     0,    34,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    14,     0,
       0,     0,     0,     0,     0,     0,    43,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    18,    26,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    27,     0,     0,     0,     0,    33,     0,    17,
      35,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      28,     0,    30,    31,    32,    36,     0,     0,     0,     0,
      42,     0,     0,     0,     0,     0,     0,     0,     0,    37,
       0,    39,    40,    41,     0,     0,     0,     0,     0,     0,
      29,     0,     0,    38,     0,     0,     0
};

static const short yydefgoto[] =
{
     394,    21,    22,    23,    24,    25,   214,    76,    93,    26,
      95
};

static const short yypact[] =
{
    1749,  1820,  1749,   -34,   -27,  1820,-32768,     8,    13,    20,
      31,    42,    48,    59,    68,    69,-32768,-32768,    71,    72,
    1780,    19,     2,-32768,    30,-32768,   181,  1820,-32768,-32768,
      89,    91,-32768,  1820,  1820,  1820,  1820,  1820,  1820,  1820,
    1820,  1820,  1820,  1820,    53,     5,    54,   -14,  1575,  1749,
    1749,   455,  1820,  1820,    93,  1820,  1820,  1820,  1820,  1820,
    1820,   -35,  1820,  1820,  1820,  1820,  1820,  1581,    88,   -11,
     506,   512,   533,   539,   560,   566,    90,   587,   593,   614,
    1601,   620,-32768,-32768,   -35,-32768,-32768,-32768,   126,    96,
    1528,  1820,  1534,    97,   444,-32768,  1858,  1858,-32768,    79,
      79,   131,   131,-32768,   131,   103,-32768,    73,  1538,  1864,
     202,   202,   -35,-32768,  1794,  1820,  1820,  1820,  1820,  1820,
    1820,  1794,  1820,  1820,  1820,-32768,  1820,   100,   108,    62,
     438,  1858,   106,     4,   464,  1820,    53,   107,  1800,   110,
     641,   647,   668,   674,   695,   701,   722,   111,   728,  1858,
     749,   755,  1607,   135,   113,-32768,-32768,   175,   254,-32768,
  -32768,   331,   385,-32768,-32768,  1858,-32768,   -35,  1820,  1820,
    1820,  1820,  1820,  1820,  1820,   -35,  1820,  1820,  1820,-32768,
    1816,-32768,-32768,-32768,-32768,-32768,   377,-32768,-32768,-32768,
  -32768,   395,   114,   776,   782,   803,   809,   830,   836,   857,
     115,  1858,   863,   884,   119,   120,   122,   123,   124,   125,
     134,   150,   162,   171,-32768,-32768,-32768,-32768,-32768,-32768,
     -35,   -35,  1820,  1820,  1820,  1820,  1820,-32768,  1820,  1820,
     177,  1820,  1820,  1820,  1820,  1820,  1820,  1820,  1820,  1820,
     172,   173,   890,   911,   917,   938,   944,   965,   971,    33,
     992,   998,  1019,  1025,  1046,  1052,    64,  1073,  1079,   -35,
     -35,   -35,  1820,  1820,  1820,  1820,   -35,  1820,-32768,  1820,
    1820,  1820,  1820,  1820,  1820,  1820,-32768,  1820,  1820,  1820,
     176,   178,   184,  1100,  1106,  1127,  1133,   187,  1154,  1160,
    1181,  1187,  1208,  1214,  1235,  1241,  1262,  1268,-32768,-32768,
     -35,   -35,  1820,   -35,   -35,   -35,   -35,  1820,  1820,  1820,
    1820,  1820,  1820,  1820,  1820,  1820,   198,   199,  1289,   203,
     204,   206,   208,  1627,  1633,  1295,  1316,  1322,  1343,  1349,
    1370,  1376,-32768,   -35,  1820,   -35,   -35,-32768,   -35,-32768,
  -32768,  1820,  1820,  1820,  1820,  1820,  1820,  1820,   207,  1397,
     210,   211,   212,  1653,  1403,  1424,  1430,  1451,  1659,  1457,
  -32768,  1820,-32768,-32768,-32768,-32768,  1820,  1820,  1820,  1820,
  -32768,  1820,  1478,  1679,  1484,  1685,  1705,  1711,   -35,-32768,
    1820,-32768,-32768,-32768,   213,  1505,   -35,  1820,   215,  1511,
  -32768,  1820,  1731,-32768,   166,   218,-32768
};

static const short yypgoto[] =
{
  -32768,    23,   -17,-32768,   193,-32768,-32768,     3,-32768,    -1,
     133
};


#define	YYLAST		1884


static const short yytable[] =
{
      28,    54,    17,    46,    32,   105,    30,    55,    56,    57,
      58,    59,    60,    31,    49,    50,    51,    52,    53,    48,
      62,    63,    64,    65,    66,    29,    67,    85,    49,    50,
     113,   114,    70,    71,    72,    73,    74,    75,    77,    78,
      79,    80,    81,    45,   106,    54,    83,   162,    33,   163,
      94,    96,    97,    34,    99,   100,   101,   102,   103,   104,
      35,   107,   108,   109,   110,   111,     1,   127,    51,    52,
      53,    36,    87,    88,   268,   269,    55,    56,    57,    58,
      59,    60,    37,     5,    57,    58,    59,    60,    38,   130,
     131,   133,    65,    66,    82,   137,    84,   139,    16,    39,
      18,    19,    27,   155,   147,   276,   277,   156,    40,    41,
       1,    42,    43,   140,   141,   142,   143,   144,   145,   146,
     148,   149,   150,   151,    68,   152,    69,     5,   157,    98,
     112,   161,   121,    94,   165,    49,   128,    67,    59,   134,
     136,   153,    16,   154,    18,    19,    27,   159,   166,   180,
     192,   160,   167,   175,   181,   219,   227,   186,   200,   230,
     231,   191,   232,   233,   234,   235,   395,   193,   194,   195,
     196,   197,   198,   199,   236,   201,   202,   203,    55,    56,
      57,    58,    59,    60,    55,    56,    57,    58,    59,    60,
     237,    62,    63,    64,    65,    66,    61,    62,    63,    64,
      65,    66,   238,   240,   241,    55,    56,    57,    58,    59,
      60,   239,   249,    47,   259,   260,   182,   298,   396,   299,
     183,   242,   243,   244,   245,   246,   300,   247,   248,   305,
     250,   251,   252,   253,   254,   255,    77,   257,   258,   332,
     256,   333,   280,   281,   282,   335,   336,   337,   360,   287,
     338,   362,   363,   364,     0,   386,   390,     0,     1,     0,
       0,   283,   284,   285,   286,     0,   288,   164,   289,   290,
     291,   292,   293,   294,   295,     5,   148,   296,   297,     0,
       0,     0,     0,   316,   317,     0,   319,   320,   321,   322,
      16,     0,    18,    19,    27,   184,     0,     0,     0,   185,
       0,   318,     0,     0,     0,     0,   323,   324,   325,   326,
     327,   328,   329,   330,   331,     0,   348,     0,   350,   351,
       0,   352,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   349,    55,    56,    57,    58,    59,    60,
     353,   354,   355,   356,   357,   358,   359,    62,    63,    64,
      65,    66,     0,     0,     0,     0,     0,     0,     0,     0,
     372,   384,     0,     0,     0,   373,   374,   375,   376,   388,
     377,     0,   187,     0,     0,     0,   188,     0,     0,   385,
      55,    56,    57,    58,    59,    60,   389,     0,     0,     1,
     392,     0,     0,    62,    63,    64,    65,    66,    55,    56,
      57,    58,    59,    60,     0,     0,     5,     0,     0,     0,
       0,    62,    63,    64,    65,    66,     0,     0,   215,     0,
       0,    16,   216,    18,    19,    27,   189,     0,     0,     0,
     190,     0,     0,     0,     0,     0,   217,     0,     0,     0,
     218,    55,    56,    57,    58,    59,    60,    55,    56,    57,
      58,    59,    60,     0,    62,    63,    64,    65,    66,     1,
      62,    63,    64,    65,    66,     0,     0,    89,     1,     0,
       0,     0,     0,     0,     0,     0,     5,     0,     0,    86,
       0,   158,     0,     0,     0,     5,     0,   135,     0,     0,
       0,    16,     0,    18,    19,    90,     0,     0,    91,    92,
      16,     0,    18,    19,    90,     0,     0,    91,    92,    55,
      56,    57,    58,    59,    60,    55,    56,    57,    58,    59,
      60,     0,    62,    63,    64,    65,    66,     0,    62,    63,
      64,    65,    66,     0,     0,     0,    55,    56,    57,    58,
      59,    60,    55,    56,    57,    58,    59,    60,   115,    62,
      63,    64,    65,    66,   116,    62,    63,    64,    65,    66,
       0,     0,     0,    55,    56,    57,    58,    59,    60,    55,
      56,    57,    58,    59,    60,   117,    62,    63,    64,    65,
      66,   118,    62,    63,    64,    65,    66,     0,     0,     0,
      55,    56,    57,    58,    59,    60,    55,    56,    57,    58,
      59,    60,   119,    62,    63,    64,    65,    66,   120,    62,
      63,    64,    65,    66,     0,     0,     0,    55,    56,    57,
      58,    59,    60,    55,    56,    57,    58,    59,    60,   122,
      62,    63,    64,    65,    66,   123,    62,    63,    64,    65,
      66,     0,     0,     0,    55,    56,    57,    58,    59,    60,
      55,    56,    57,    58,    59,    60,   124,    62,    63,    64,
      65,    66,   126,    62,    63,    64,    65,    66,     0,     0,
       0,    55,    56,    57,    58,    59,    60,    55,    56,    57,
      58,    59,    60,   168,    62,    63,    64,    65,    66,   169,
      62,    63,    64,    65,    66,     0,     0,     0,    55,    56,
      57,    58,    59,    60,    55,    56,    57,    58,    59,    60,
     170,    62,    63,    64,    65,    66,   171,    62,    63,    64,
      65,    66,     0,     0,     0,    55,    56,    57,    58,    59,
      60,    55,    56,    57,    58,    59,    60,   172,    62,    63,
      64,    65,    66,   173,    62,    63,    64,    65,    66,     0,
       0,     0,    55,    56,    57,    58,    59,    60,    55,    56,
      57,    58,    59,    60,   174,    62,    63,    64,    65,    66,
     176,    62,    63,    64,    65,    66,     0,     0,     0,    55,
      56,    57,    58,    59,    60,    55,    56,    57,    58,    59,
      60,   177,    62,    63,    64,    65,    66,   178,    62,    63,
      64,    65,    66,     0,     0,     0,    55,    56,    57,    58,
      59,    60,    55,    56,    57,    58,    59,    60,   220,    62,
      63,    64,    65,    66,   221,    62,    63,    64,    65,    66,
       0,     0,     0,    55,    56,    57,    58,    59,    60,    55,
      56,    57,    58,    59,    60,   222,    62,    63,    64,    65,
      66,   223,    62,    63,    64,    65,    66,     0,     0,     0,
      55,    56,    57,    58,    59,    60,    55,    56,    57,    58,
      59,    60,   224,    62,    63,    64,    65,    66,   225,    62,
      63,    64,    65,    66,     0,     0,     0,    55,    56,    57,
      58,    59,    60,    55,    56,    57,    58,    59,    60,   226,
      62,    63,    64,    65,    66,   228,    62,    63,    64,    65,
      66,     0,     0,     0,    55,    56,    57,    58,    59,    60,
      55,    56,    57,    58,    59,    60,   229,    62,    63,    64,
      65,    66,   261,    62,    63,    64,    65,    66,     0,     0,
       0,    55,    56,    57,    58,    59,    60,    55,    56,    57,
      58,    59,    60,   262,    62,    63,    64,    65,    66,   263,
      62,    63,    64,    65,    66,     0,     0,     0,    55,    56,
      57,    58,    59,    60,    55,    56,    57,    58,    59,    60,
     264,    62,    63,    64,    65,    66,   265,    62,    63,    64,
      65,    66,     0,     0,     0,    55,    56,    57,    58,    59,
      60,    55,    56,    57,    58,    59,    60,   266,    62,    63,
      64,    65,    66,   267,    62,    63,    64,    65,    66,     0,
       0,     0,    55,    56,    57,    58,    59,    60,    55,    56,
      57,    58,    59,    60,   270,    62,    63,    64,    65,    66,
     271,    62,    63,    64,    65,    66,     0,     0,     0,    55,
      56,    57,    58,    59,    60,    55,    56,    57,    58,    59,
      60,   272,    62,    63,    64,    65,    66,   273,    62,    63,
      64,    65,    66,     0,     0,     0,    55,    56,    57,    58,
      59,    60,    55,    56,    57,    58,    59,    60,   274,    62,
      63,    64,    65,    66,   275,    62,    63,    64,    65,    66,
       0,     0,     0,    55,    56,    57,    58,    59,    60,    55,
      56,    57,    58,    59,    60,   278,    62,    63,    64,    65,
      66,   279,    62,    63,    64,    65,    66,     0,     0,     0,
      55,    56,    57,    58,    59,    60,    55,    56,    57,    58,
      59,    60,   301,    62,    63,    64,    65,    66,   302,    62,
      63,    64,    65,    66,     0,     0,     0,    55,    56,    57,
      58,    59,    60,    55,    56,    57,    58,    59,    60,   303,
      62,    63,    64,    65,    66,   304,    62,    63,    64,    65,
      66,     0,     0,     0,    55,    56,    57,    58,    59,    60,
      55,    56,    57,    58,    59,    60,   306,    62,    63,    64,
      65,    66,   307,    62,    63,    64,    65,    66,     0,     0,
       0,    55,    56,    57,    58,    59,    60,    55,    56,    57,
      58,    59,    60,   308,    62,    63,    64,    65,    66,   309,
      62,    63,    64,    65,    66,     0,     0,     0,    55,    56,
      57,    58,    59,    60,    55,    56,    57,    58,    59,    60,
     310,    62,    63,    64,    65,    66,   311,    62,    63,    64,
      65,    66,     0,     0,     0,    55,    56,    57,    58,    59,
      60,    55,    56,    57,    58,    59,    60,   312,    62,    63,
      64,    65,    66,   313,    62,    63,    64,    65,    66,     0,
       0,     0,    55,    56,    57,    58,    59,    60,    55,    56,
      57,    58,    59,    60,   314,    62,    63,    64,    65,    66,
     315,    62,    63,    64,    65,    66,     0,     0,     0,    55,
      56,    57,    58,    59,    60,    55,    56,    57,    58,    59,
      60,   334,    62,    63,    64,    65,    66,   341,    62,    63,
      64,    65,    66,     0,     0,     0,    55,    56,    57,    58,
      59,    60,    55,    56,    57,    58,    59,    60,   342,    62,
      63,    64,    65,    66,   343,    62,    63,    64,    65,    66,
       0,     0,     0,    55,    56,    57,    58,    59,    60,    55,
      56,    57,    58,    59,    60,   344,    62,    63,    64,    65,
      66,   345,    62,    63,    64,    65,    66,     0,     0,     0,
      55,    56,    57,    58,    59,    60,    55,    56,    57,    58,
      59,    60,   346,    62,    63,    64,    65,    66,   347,    62,
      63,    64,    65,    66,     0,     0,     0,    55,    56,    57,
      58,    59,    60,    55,    56,    57,    58,    59,    60,   361,
      62,    63,    64,    65,    66,   366,    62,    63,    64,    65,
      66,     0,     0,     0,    55,    56,    57,    58,    59,    60,
      55,    56,    57,    58,    59,    60,   367,    62,    63,    64,
      65,    66,   368,    62,    63,    64,    65,    66,     0,     0,
       0,    55,    56,    57,    58,    59,    60,    55,    56,    57,
      58,    59,    60,   369,    62,    63,    64,    65,    66,   371,
      62,    63,    64,    65,    66,     0,     0,     0,    55,    56,
      57,    58,    59,    60,    55,    56,    57,    58,    59,    60,
     378,    62,    63,    64,    65,    66,   380,    62,    63,    64,
      65,    66,     1,     0,     0,     0,     0,     0,     1,     0,
       0,    55,    56,    57,    58,    59,    60,   387,     0,     5,
       0,     0,     0,   391,    62,     5,    64,    65,    66,     0,
       0,     0,     0,     0,    16,     0,    18,    19,    27,     0,
      16,   129,    18,    19,    27,     0,     0,   132,    55,    56,
      57,    58,    59,    60,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,     0,    62,    63,    64,
      65,    66,     0,     0,    55,    56,    57,    58,    59,    60,
      55,    56,    57,    58,    59,    60,    86,    62,    63,    64,
      65,    66,    86,    62,    63,    64,    65,    66,     0,     0,
      55,    56,    57,    58,    59,    60,    55,    56,    57,    58,
      59,    60,   125,    62,    63,    64,    65,    66,   179,    62,
      63,    64,    65,    66,     0,     0,    55,    56,    57,    58,
      59,    60,    55,    56,    57,    58,    59,    60,   339,    62,
      63,    64,    65,    66,   340,    62,    63,    64,    65,    66,
       0,     0,    55,    56,    57,    58,    59,    60,    55,    56,
      57,    58,    59,    60,   365,    62,    63,    64,    65,    66,
     370,    62,    63,    64,    65,    66,     0,     0,    55,    56,
      57,    58,    59,    60,    55,    56,    57,    58,    59,    60,
     379,    62,    63,    64,    65,    66,   381,    62,    63,    64,
      65,    66,     0,     0,    55,    56,    57,    58,    59,    60,
       0,     0,     0,     0,     0,     0,   382,    62,    63,    64,
      65,    66,   383,     1,     0,     0,     0,     0,     0,     0,
       2,     3,     4,     0,     0,     0,     0,     0,     0,     0,
       5,     6,   393,     0,     0,     7,     8,     9,    10,    11,
      12,    13,    14,    15,     1,    16,    17,    18,    19,    20,
       0,     2,     3,     4,     0,     0,     0,     0,     1,     0,
       0,     5,     6,     0,     1,     0,     7,     8,     9,    10,
      11,    12,    13,    14,    15,     5,    16,    44,    18,    19,
      20,     5,     0,     0,     1,     0,     0,     0,     0,   204,
      16,    17,    18,    19,   138,     0,    16,   136,    18,    19,
      27,     5,   205,   206,   207,   208,   209,   210,   211,   212,
     213,     0,     0,     0,     0,     0,    16,     0,    18,    19,
      27,    55,    56,    57,    58,    59,    60,    55,    56,    57,
      58,    59,    60,     0,    62,    63,    64,    65,    66,     0,
      62,     0,     0,    65,    66
};

static const short yycheck[] =
{
       1,    15,    37,    20,     5,    40,    40,     3,     4,     5,
       6,     7,     8,    40,     9,    10,    14,    15,    16,    20,
      16,    17,    18,    19,    20,     2,    27,    41,     9,    10,
      41,    42,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    20,    61,    15,    41,    43,    40,    45,
      51,    52,    53,    40,    55,    56,    57,    58,    59,    60,
      40,    62,    63,    64,    65,    66,     4,    84,    14,    15,
      16,    40,    49,    50,    41,    42,     3,     4,     5,     6,
       7,     8,    40,    21,     5,     6,     7,     8,    40,    90,
      91,    92,    19,    20,    41,   112,    42,   114,    36,    40,
      38,    39,    40,    41,   121,    41,    42,    45,    40,    40,
       4,    40,    40,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,    35,   126,    35,    21,   129,    36,
      42,   132,    42,   134,   135,     9,    40,   138,     7,    42,
      37,    41,    36,    35,    38,    39,    40,    41,    41,    14,
     167,    45,    42,    42,    41,    41,    41,   158,   175,    40,
      40,   162,    40,    40,    40,    40,     0,   168,   169,   170,
     171,   172,   173,   174,    40,   176,   177,   178,     3,     4,
       5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
      40,    16,    17,    18,    19,    20,    15,    16,    17,    18,
      19,    20,    40,   220,   221,     3,     4,     5,     6,     7,
       8,    40,    35,    20,    42,    42,    41,    41,     0,    41,
      45,   222,   223,   224,   225,   226,    42,   228,   229,    42,
     231,   232,   233,   234,   235,   236,   237,   238,   239,    41,
     237,    42,   259,   260,   261,    42,    42,    41,    41,   266,
      42,    41,    41,    41,    -1,    42,    41,    -1,     4,    -1,
      -1,   262,   263,   264,   265,    -1,   267,   134,   269,   270,
     271,   272,   273,   274,   275,    21,   277,   278,   279,    -1,
      -1,    -1,    -1,   300,   301,    -1,   303,   304,   305,   306,
      36,    -1,    38,    39,    40,    41,    -1,    -1,    -1,    45,
      -1,   302,    -1,    -1,    -1,    -1,   307,   308,   309,   310,
     311,   312,   313,   314,   315,    -1,   333,    -1,   335,   336,
      -1,   338,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   334,     3,     4,     5,     6,     7,     8,
     341,   342,   343,   344,   345,   346,   347,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     361,   378,    -1,    -1,    -1,   366,   367,   368,   369,   386,
     371,    -1,    41,    -1,    -1,    -1,    45,    -1,    -1,   380,
       3,     4,     5,     6,     7,     8,   387,    -1,    -1,     4,
     391,    -1,    -1,    16,    17,    18,    19,    20,     3,     4,
       5,     6,     7,     8,    -1,    -1,    21,    -1,    -1,    -1,
      -1,    16,    17,    18,    19,    20,    -1,    -1,    41,    -1,
      -1,    36,    45,    38,    39,    40,    41,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,
      45,     3,     4,     5,     6,     7,     8,     3,     4,     5,
       6,     7,     8,    -1,    16,    17,    18,    19,    20,     4,
      16,    17,    18,    19,    20,    -1,    -1,    12,     4,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    21,    -1,    -1,    41,
      -1,    43,    -1,    -1,    -1,    21,    -1,    43,    -1,    -1,
      -1,    36,    -1,    38,    39,    40,    -1,    -1,    43,    44,
      36,    -1,    38,    39,    40,    -1,    -1,    43,    44,     3,
       4,     5,     6,     7,     8,     3,     4,     5,     6,     7,
       8,    -1,    16,    17,    18,    19,    20,    -1,    16,    17,
      18,    19,    20,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     3,     4,     5,     6,     7,     8,    42,    16,
      17,    18,    19,    20,    42,    16,    17,    18,    19,    20,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     3,
       4,     5,     6,     7,     8,    42,    16,    17,    18,    19,
      20,    42,    16,    17,    18,    19,    20,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
       7,     8,    42,    16,    17,    18,    19,    20,    42,    16,
      17,    18,    19,    20,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,     3,     4,     5,     6,     7,     8,    42,
      16,    17,    18,    19,    20,    42,    16,    17,    18,    19,
      20,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
       3,     4,     5,     6,     7,     8,    42,    16,    17,    18,
      19,    20,    42,    16,    17,    18,    19,    20,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     3,     4,     5,
       6,     7,     8,    42,    16,    17,    18,    19,    20,    42,
      16,    17,    18,    19,    20,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
      42,    16,    17,    18,    19,    20,    42,    16,    17,    18,
      19,    20,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,     3,     4,     5,     6,     7,     8,    42,    16,    17,
      18,    19,    20,    42,    16,    17,    18,    19,    20,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     3,     4,
       5,     6,     7,     8,    42,    16,    17,    18,    19,    20,
      42,    16,    17,    18,    19,    20,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,     3,     4,     5,     6,     7,
       8,    42,    16,    17,    18,    19,    20,    42,    16,    17,
      18,    19,    20,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     3,     4,     5,     6,     7,     8,    42,    16,
      17,    18,    19,    20,    42,    16,    17,    18,    19,    20,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     3,
       4,     5,     6,     7,     8,    42,    16,    17,    18,    19,
      20,    42,    16,    17,    18,    19,    20,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
       7,     8,    42,    16,    17,    18,    19,    20,    42,    16,
      17,    18,    19,    20,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,     3,     4,     5,     6,     7,     8,    42,
      16,    17,    18,    19,    20,    42,    16,    17,    18,    19,
      20,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
       3,     4,     5,     6,     7,     8,    42,    16,    17,    18,
      19,    20,    42,    16,    17,    18,    19,    20,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     3,     4,     5,
       6,     7,     8,    42,    16,    17,    18,    19,    20,    42,
      16,    17,    18,    19,    20,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
      42,    16,    17,    18,    19,    20,    42,    16,    17,    18,
      19,    20,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,     3,     4,     5,     6,     7,     8,    42,    16,    17,
      18,    19,    20,    42,    16,    17,    18,    19,    20,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     3,     4,
       5,     6,     7,     8,    42,    16,    17,    18,    19,    20,
      42,    16,    17,    18,    19,    20,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,     3,     4,     5,     6,     7,
       8,    42,    16,    17,    18,    19,    20,    42,    16,    17,
      18,    19,    20,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     3,     4,     5,     6,     7,     8,    42,    16,
      17,    18,    19,    20,    42,    16,    17,    18,    19,    20,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     3,
       4,     5,     6,     7,     8,    42,    16,    17,    18,    19,
      20,    42,    16,    17,    18,    19,    20,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
       7,     8,    42,    16,    17,    18,    19,    20,    42,    16,
      17,    18,    19,    20,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,     3,     4,     5,     6,     7,     8,    42,
      16,    17,    18,    19,    20,    42,    16,    17,    18,    19,
      20,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
       3,     4,     5,     6,     7,     8,    42,    16,    17,    18,
      19,    20,    42,    16,    17,    18,    19,    20,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     3,     4,     5,
       6,     7,     8,    42,    16,    17,    18,    19,    20,    42,
      16,    17,    18,    19,    20,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
      42,    16,    17,    18,    19,    20,    42,    16,    17,    18,
      19,    20,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,     3,     4,     5,     6,     7,     8,    42,    16,    17,
      18,    19,    20,    42,    16,    17,    18,    19,    20,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     3,     4,
       5,     6,     7,     8,    42,    16,    17,    18,    19,    20,
      42,    16,    17,    18,    19,    20,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,     3,     4,     5,     6,     7,
       8,    42,    16,    17,    18,    19,    20,    42,    16,    17,
      18,    19,    20,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     3,     4,     5,     6,     7,     8,    42,    16,
      17,    18,    19,    20,    42,    16,    17,    18,    19,    20,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     3,
       4,     5,     6,     7,     8,    42,    16,    17,    18,    19,
      20,    42,    16,    17,    18,    19,    20,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
       7,     8,    42,    16,    17,    18,    19,    20,    42,    16,
      17,    18,    19,    20,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,     3,     4,     5,     6,     7,     8,    42,
      16,    17,    18,    19,    20,    42,    16,    17,    18,    19,
      20,    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,
       3,     4,     5,     6,     7,     8,    42,    16,    17,    18,
      19,    20,    42,    16,    17,    18,    19,    20,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     3,     4,     5,
       6,     7,     8,    42,    16,    17,    18,    19,    20,    42,
      16,    17,    18,    19,    20,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
      42,    16,    17,    18,    19,    20,    42,    16,    17,    18,
      19,    20,     4,    -1,    -1,    -1,    -1,    -1,     4,    -1,
      -1,     3,     4,     5,     6,     7,     8,    42,    -1,    21,
      -1,    -1,    -1,    42,    16,    21,    18,    19,    20,    -1,
      -1,    -1,    -1,    -1,    36,    -1,    38,    39,    40,    -1,
      36,    43,    38,    39,    40,    -1,    -1,    43,     3,     4,
       5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
      15,    16,    17,    18,    19,    20,    -1,    16,    17,    18,
      19,    20,    -1,    -1,     3,     4,     5,     6,     7,     8,
       3,     4,     5,     6,     7,     8,    41,    16,    17,    18,
      19,    20,    41,    16,    17,    18,    19,    20,    -1,    -1,
       3,     4,     5,     6,     7,     8,     3,     4,     5,     6,
       7,     8,    41,    16,    17,    18,    19,    20,    41,    16,
      17,    18,    19,    20,    -1,    -1,     3,     4,     5,     6,
       7,     8,     3,     4,     5,     6,     7,     8,    41,    16,
      17,    18,    19,    20,    41,    16,    17,    18,    19,    20,
      -1,    -1,     3,     4,     5,     6,     7,     8,     3,     4,
       5,     6,     7,     8,    41,    16,    17,    18,    19,    20,
      41,    16,    17,    18,    19,    20,    -1,    -1,     3,     4,
       5,     6,     7,     8,     3,     4,     5,     6,     7,     8,
      41,    16,    17,    18,    19,    20,    41,    16,    17,    18,
      19,    20,    -1,    -1,     3,     4,     5,     6,     7,     8,
      -1,    -1,    -1,    -1,    -1,    -1,    41,    16,    17,    18,
      19,    20,    41,     4,    -1,    -1,    -1,    -1,    -1,    -1,
      11,    12,    13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      21,    22,    41,    -1,    -1,    26,    27,    28,    29,    30,
      31,    32,    33,    34,     4,    36,    37,    38,    39,    40,
      -1,    11,    12,    13,    -1,    -1,    -1,    -1,     4,    -1,
      -1,    21,    22,    -1,     4,    -1,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    21,    36,    37,    38,    39,
      40,    21,    -1,    -1,     4,    -1,    -1,    -1,    -1,    13,
      36,    37,    38,    39,    40,    -1,    36,    37,    38,    39,
      40,    21,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    36,    -1,    38,    39,
      40,     3,     4,     5,     6,     7,     8,     3,     4,     5,
       6,     7,     8,    -1,    16,    17,    18,    19,    20,    -1,
      16,    -1,    -1,    19,    20
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 3:
#line 108 "DssParser.y"
{ dssBuilder.negateDss(); }
    break;
case 4:
#line 109 "DssParser.y"
{ dssBuilder.andDss(); }
    break;
case 5:
#line 110 "DssParser.y"
{ dssBuilder.orDss(); }
    break;
case 6:
#line 111 "DssParser.y"
{ dssBuilder.newDss(); }
    break;
case 7:
#line 114 "DssParser.y"
{ yyval.yAxisName = yyvsp[0].yAxisName; }
    break;
case 8:
#line 115 "DssParser.y"
{ yyval.yAxisName = yyvsp[-1].yAxisName; }
    break;
case 10:
#line 120 "DssParser.y"
{ if(yyFilteredTable){
                                    const Column *ctemp = yyFilteredTable->column(*yyvsp[-2].yAxisName);
                                    dssBuilder.currentComponent()->
                                            addRangeFilter(ctemp, *yyvsp[0].yRangeList);
                                  }else{
                                    dssBuilder.currentComponent()->
                                            addRangeFilter(*yyvsp[-2].yAxisName, *yyvsp[0].yRangeList);
                                  }
                                  delete yyvsp[-2].yAxisName;
                                  delete yyvsp[0].yRangeList; 
                                }
    break;
case 11:
#line 132 "DssParser.y"
{ if( (yyvsp[-1].yRelOp != EqOpT && yyvsp[-1].yRelOp != NeOpT) || yyvsp[0].yNumber != 0 ){
				    selerrstr<<"Bit mask filter must be tested against \"== 0\" "
					     <<" or \"!= 0\"."
					     <<selerror("BitMaskTesting");
  				    SELTHROW(DssBuilder::MiscException);
				  }
				  if(yyvsp[-1].yRelOp==NeOpT) !(*yyvsp[-2].yDSfilter);
                                }
    break;
case 12:
#line 141 "DssParser.y"
{ if(yyFilteredTable){
                                    const Column *ctemp = yyFilteredTable->column(*yyvsp[-5].yAxisName);
                                    dssBuilder.currentComponent()->
                                           addBlockFilter(ctemp, *yyvsp[-1].yBlockSpec);
                                  }else{
                                    dssBuilder.currentComponent()->
                                            addBlockFilter(*yyvsp[-5].yAxisName, *yyvsp[-1].yBlockSpec);
                                  }
                                  delete yyvsp[-5].yAxisName;
                                  delete yyvsp[-1].yBlockSpec;
                                }
    break;
case 13:
#line 153 "DssParser.y"
{ if(yyFilteredTable){
                                    const Column *ctemp = yyFilteredTable->column(*yyvsp[-1].yAxisName);
                                    dssBuilder.currentComponent()->
                                            addBlockFilter(ctemp, *yyvsp[-3].yBlockSpec);
                                  }else{
                                    dssBuilder.currentComponent()->
                                            addBlockFilter(*yyvsp[-1].yAxisName, *yyvsp[-3].yBlockSpec);
                                  }
                                  delete yyvsp[-3].yBlockSpec;
                                  delete yyvsp[-1].yAxisName;
                                }
    break;
case 14:
#line 165 "DssParser.y"
{ DSS::DSfilterComp fcomp(2);
                                  fcomp[0] = *yyvsp[-8].yAxisName;
                                  fcomp[1] = *yyvsp[-6].yAxisName;
                                  dssBuilder.currentComponent()->
                                           addBlockFilter(dssBuilder.Axis2dName(fcomp), *yyvsp[-1].yBlockSpec, fcomp);
                                  delete yyvsp[-8].yAxisName;
                                  delete yyvsp[-6].yAxisName;
                                }
    break;
case 15:
#line 174 "DssParser.y"
{ DSS::DSfilterComp fcomp(2);
                                  dssBuilder.currentComponent()->
                                           addBlockFilter(dssBuilder.Axis2dName(fcomp), *yyvsp[-1].yBlockSpec);
                                }
    break;
case 16:
#line 179 "DssParser.y"
{ DSS::DSfilterComp fcomp(2);
                                  fcomp[0] = *yyvsp[-3].yAxisName;
                                  fcomp[1] = *yyvsp[-1].yAxisName;
                                  dssBuilder.currentComponent()->
                                           addBlockFilter(dssBuilder.Axis2dName(fcomp), *yyvsp[-5].yBlockSpec, fcomp);
                                  delete yyvsp[-3].yAxisName;
                                  delete yyvsp[-1].yAxisName;
                                }
    break;
case 17:
#line 188 "DssParser.y"
{ if( yyvsp[-3].yNumber != 0 || yyvsp[-1].yNumber != 0 ){
				    selerrstr<<"Mask filter must have zero offset in the data subspace."
					     <<selerror("MaskSpecOffset");
  				    SELTHROW(DssBuilder::MiscException);
				  }
				  DSS::DSfilterComp fcomp(2);
                                  fcomp[0] = *yyvsp[-12].yAxisName;
                                  fcomp[1] = *yyvsp[-10].yAxisName;
                                  dssBuilder.currentComponent()->
                                           addBlockFilter(dssBuilder.Axis2dName(fcomp), *yyvsp[-5].yBlockSpec, fcomp);
                                  delete yyvsp[-12].yAxisName;
                                  delete yyvsp[-10].yAxisName;
                                }
    break;
case 18:
#line 202 "DssParser.y"
{ if( yyvsp[-7].yNumber != 0 || yyvsp[-5].yNumber != 0 ){
				    selerrstr<<"Mask filter must have zero offset in the data subspace."
					     <<selerror("MaskSpecOffset");
  				    SELTHROW(DssBuilder::MiscException);
				  }
				  DSS::DSfilterComp fcomp(2);
                                  fcomp[0] = *yyvsp[-3].yAxisName;
                                  fcomp[1] = *yyvsp[-1].yAxisName;
                                  dssBuilder.currentComponent()->
                                           addBlockFilter(dssBuilder.Axis2dName(fcomp), *yyvsp[-9].yBlockSpec, fcomp);
                                  delete yyvsp[-3].yAxisName;
                                  delete yyvsp[-1].yAxisName;
                                }
    break;
case 19:
#line 216 "DssParser.y"
{ DRangeList rlist;
				  switch (yyvsp[-1].yRelOp) {
				  case LtOpT:{
				    DRange range(-DBL_MAX, yyvsp[0].yNumber, Unbounded, Open);
				    rlist.push_back(range);
				    break; }
				  case LeOpT:{
				    DRange range(-DBL_MAX, yyvsp[0].yNumber, Unbounded, Closed);
				    rlist.push_back(range);
				    break; }
				  case GtOpT:{
				    DRange range(yyvsp[0].yNumber, DBL_MAX, Open, Unbounded);
				    rlist.push_back(range);
				    break; }
				  case GeOpT:{
				    DRange range(yyvsp[0].yNumber, DBL_MAX, Closed, Unbounded);
				    rlist.push_back(range);
				    break; }
				  case EqOpT:{
				    DRange range(yyvsp[0].yNumber, yyvsp[0].yNumber, Closed, Closed);
				    rlist.push_back(range);
				    break; }
				  case NeOpT:{
				    DRange range1(yyvsp[0].yNumber, DBL_MAX, Open, Unbounded);
				    DRange range2(-DBL_MAX, yyvsp[0].yNumber, Unbounded, Open);
				    rlist.push_back(range1);
				    rlist.push_back(range2);
				    break; }
				  }

				  if(yyFilteredTable){
				    const Column *ctemp = yyFilteredTable->column(*yyvsp[-2].yAxisName);
				    dssBuilder.currentComponent()->
				                   addRangeFilter(ctemp, rlist);
				  }else{
				    dssBuilder.currentComponent()->
				                   addRangeFilter(*yyvsp[-2].yAxisName, rlist);
				  }

                                  delete yyvsp[-2].yAxisName;
				}
    break;
case 20:
#line 258 "DssParser.y"
{ DRangeList rlist;
				  switch (yyvsp[-1].yRelOp) {
				  case GtOpT:{
				    DRange range(-DBL_MAX, yyvsp[-2].yNumber, Unbounded, Open);
				    rlist.push_back(range);
				    break; }
				  case GeOpT:{
				    DRange range(-DBL_MAX, yyvsp[-2].yNumber, Unbounded, Closed);
				    rlist.push_back(range);
				    break; }
				  case LtOpT:{
				    DRange range(yyvsp[-2].yNumber, DBL_MAX, Open, Unbounded);
				    rlist.push_back(range);
				    break; }
				  case LeOpT:{
				    DRange range(yyvsp[-2].yNumber, DBL_MAX, Closed, Unbounded);
				    rlist.push_back(range);
				    break; }
				  case EqOpT:{
				    DRange range(yyvsp[-2].yNumber, yyvsp[-2].yNumber, Closed, Closed);
				    rlist.push_back(range);
				    break; }
                                  case NeOpT:{
				    DRange range1(yyvsp[-2].yNumber, DBL_MAX, Open, Unbounded);
				    DRange range2(-DBL_MAX, yyvsp[-2].yNumber, Unbounded, Open);
				    rlist.push_back(range1);
				    rlist.push_back(range2);
				    break; }
				  }

				  if(yyFilteredTable){
				    const Column *ctemp = yyFilteredTable->column(*yyvsp[0].yAxisName);
				    dssBuilder.currentComponent()->
				                   addRangeFilter(ctemp, rlist);
				  }else{
				    dssBuilder.currentComponent()->
				                   addRangeFilter(*yyvsp[0].yAxisName, rlist);
				  }
                                  delete yyvsp[0].yAxisName;
				}
    break;
case 21:
#line 299 "DssParser.y"
{ GeoRegion r;
                                  r.push_back(
                                        *dssBuilder.currentRegionComponent());
                                  DSS::DSfilterComp fc(2);
                                  fc[0] = dssBuilder.xAxisName();
                                  fc[1] = dssBuilder.yAxisName();
                                  dssBuilder.currentComponent()->
                                          addRegionFilter(dssBuilder.Axis2dName(fc), r, fc);
                                }
    break;
case 22:
#line 311 "DssParser.y"
{ DSfilter *dsbit=0;
				  vector<unsigned long> onBits;
				  vector<unsigned long> offBits;
				  onBits.push_back(0);
				  offBits.push_back(ULNG(yyvsp[0].yNumber));
				  if(yyFilteredTable){
                                    const Column *ctemp = yyFilteredTable->column(*yyvsp[-2].yAxisName);
                                    dsbit = dssBuilder.currentComponent()->
				               addBitFilter(ctemp, onBits, offBits);
                                  }else{
                                    dsbit = dssBuilder.currentComponent()->
                                               addBitFilter(*yyvsp[-2].yAxisName, onBits, offBits);
                                  }
                                  delete yyvsp[-2].yAxisName;
				  yyval.yDSfilter = dsbit;
				}
    break;
case 23:
#line 328 "DssParser.y"
{yyval.yDSfilter=yyvsp[-1].yDSfilter;}
    break;
case 25:
#line 332 "DssParser.y"
{ dssBuilder.regionAxes(*yyvsp[-5].yAxisName, *yyvsp[-3].yAxisName);
                                  delete yyvsp[-5].yAxisName; delete yyvsp[-3].yAxisName; }
    break;
case 26:
#line 335 "DssParser.y"
{ dssBuilder.addRegion(new FCircle(FPoint(yyvsp[-9].yNumber, yyvsp[-7].yNumber), yyvsp[-5].yNumber));
                    dssBuilder.regionAxes(*yyvsp[-3].yAxisName, *yyvsp[-1].yAxisName);
                    delete yyvsp[-3].yAxisName; delete yyvsp[-1].yAxisName;
		  }
    break;
case 27:
#line 340 "DssParser.y"
{ dssBuilder.addRegion(new FAnnulus(FPoint(yyvsp[-11].yNumber, yyvsp[-9].yNumber), yyvsp[-7].yNumber, yyvsp[-5].yNumber)); 
                    dssBuilder.regionAxes(*yyvsp[-3].yAxisName, *yyvsp[-1].yAxisName);
                    delete yyvsp[-3].yAxisName; delete yyvsp[-1].yAxisName;
		  }
    break;
case 28:
#line 345 "DssParser.y"
{ dssBuilder.addRegion(new FEllipse(FPoint(yyvsp[-13].yNumber, yyvsp[-11].yNumber), yyvsp[-9].yNumber, yyvsp[-7].yNumber, yyvsp[-5].yNumber));
                    dssBuilder.regionAxes(*yyvsp[-3].yAxisName, *yyvsp[-1].yAxisName);
                    delete yyvsp[-3].yAxisName; delete yyvsp[-1].yAxisName;
		  }
    break;
case 29:
#line 350 "DssParser.y"
{ dssBuilder.addRegion(new FElliptAnnulus(FPoint(yyvsp[-19].yNumber, yyvsp[-17].yNumber), yyvsp[-15].yNumber, yyvsp[-13].yNumber, yyvsp[-11].yNumber, yyvsp[-9].yNumber, yyvsp[-7].yNumber, yyvsp[-5].yNumber)); 
                    dssBuilder.regionAxes(*yyvsp[-3].yAxisName, *yyvsp[-1].yAxisName);
                    delete yyvsp[-3].yAxisName; delete yyvsp[-1].yAxisName;
		  }
    break;
case 30:
#line 355 "DssParser.y"
{ dssBuilder.addRegion(new FRotBox(FPoint(yyvsp[-13].yNumber, yyvsp[-11].yNumber), 2*yyvsp[-9].yNumber, 2*yyvsp[-7].yNumber, yyvsp[-5].yNumber));
                    dssBuilder.regionAxes(*yyvsp[-3].yAxisName, *yyvsp[-1].yAxisName);
                    delete yyvsp[-3].yAxisName; delete yyvsp[-1].yAxisName;
		  }
    break;
case 31:
#line 360 "DssParser.y"
{ dssBuilder.addRegion(new FRotRectangle(FPoint(yyvsp[-13].yNumber, yyvsp[-11].yNumber), FPoint(yyvsp[-9].yNumber, yyvsp[-7].yNumber), yyvsp[-5].yNumber));
                    dssBuilder.regionAxes(*yyvsp[-3].yAxisName, *yyvsp[-1].yAxisName);
                    delete yyvsp[-3].yAxisName; delete yyvsp[-1].yAxisName;
		  }
    break;
case 32:
#line 365 "DssParser.y"
{ dssBuilder.addRegion(new FRotRhombus(FPoint(yyvsp[-13].yNumber, yyvsp[-11].yNumber), yyvsp[-9].yNumber, yyvsp[-7].yNumber, yyvsp[-5].yNumber));
                    dssBuilder.regionAxes(*yyvsp[-3].yAxisName, *yyvsp[-1].yAxisName);
                    delete yyvsp[-3].yAxisName; delete yyvsp[-1].yAxisName;
		  }
    break;
case 33:
#line 370 "DssParser.y"
{ dssBuilder.addRegion(new FSector(FPoint(yyvsp[-11].yNumber, yyvsp[-9].yNumber), yyvsp[-7].yNumber, yyvsp[-5].yNumber)); 
                    dssBuilder.regionAxes(*yyvsp[-3].yAxisName, *yyvsp[-1].yAxisName);
                    delete yyvsp[-3].yAxisName; delete yyvsp[-1].yAxisName;
		  }
    break;
case 34:
#line 375 "DssParser.y"
{ dssBuilder.addRegion(new FPolygon(yyvsp[-5].yPointList[0], yyvsp[-5].yPointList[1], yyvsp[-5].yPointList[0].size()));
                    delete [] yyvsp[-5].yPointList; 
                    dssBuilder.regionAxes(*yyvsp[-3].yAxisName, *yyvsp[-1].yAxisName);
                    delete yyvsp[-3].yAxisName; delete yyvsp[-1].yAxisName;
		  }
    break;
case 35:
#line 383 "DssParser.y"
{ dssBuilder.addRegion(new FCircle(FPoint(yyvsp[-5].yNumber, yyvsp[-3].yNumber), yyvsp[-1].yNumber)); 
	  }
    break;
case 36:
#line 386 "DssParser.y"
{ dssBuilder.addRegion(new FAnnulus(FPoint(yyvsp[-7].yNumber, yyvsp[-5].yNumber), yyvsp[-3].yNumber, yyvsp[-1].yNumber)); 
	  }
    break;
case 37:
#line 389 "DssParser.y"
{ dssBuilder.addRegion(new FEllipse(FPoint(yyvsp[-9].yNumber, yyvsp[-7].yNumber), yyvsp[-5].yNumber, yyvsp[-3].yNumber, yyvsp[-1].yNumber));
	  }
    break;
case 38:
#line 392 "DssParser.y"
{ dssBuilder.addRegion(new FElliptAnnulus(FPoint(yyvsp[-15].yNumber, yyvsp[-13].yNumber), yyvsp[-11].yNumber, yyvsp[-9].yNumber, yyvsp[-7].yNumber, yyvsp[-5].yNumber, yyvsp[-3].yNumber, yyvsp[-1].yNumber)); 
	  }
    break;
case 39:
#line 395 "DssParser.y"
{ dssBuilder.addRegion(new FRotBox(FPoint(yyvsp[-9].yNumber, yyvsp[-7].yNumber), 2*yyvsp[-5].yNumber, 2*yyvsp[-3].yNumber, yyvsp[-1].yNumber));
	  }
    break;
case 40:
#line 398 "DssParser.y"
{ dssBuilder.addRegion(new FRotRectangle(FPoint(yyvsp[-9].yNumber, yyvsp[-7].yNumber), FPoint(yyvsp[-5].yNumber, yyvsp[-3].yNumber), yyvsp[-1].yNumber));
	  }
    break;
case 41:
#line 401 "DssParser.y"
{ dssBuilder.addRegion(new FRotRhombus(FPoint(yyvsp[-9].yNumber, yyvsp[-7].yNumber), yyvsp[-5].yNumber, yyvsp[-3].yNumber, yyvsp[-1].yNumber));
	  }
    break;
case 42:
#line 404 "DssParser.y"
{ dssBuilder.addRegion(new FSector(FPoint(yyvsp[-7].yNumber, yyvsp[-5].yNumber), yyvsp[-3].yNumber, yyvsp[-1].yNumber)); 
	  }
    break;
case 43:
#line 407 "DssParser.y"
{ dssBuilder.addRegion(new FPolygon(yyvsp[-1].yPointList[0], yyvsp[-1].yPointList[1], yyvsp[-1].yPointList[0].size()));
            delete [] yyvsp[-1].yPointList; 
	  }
    break;
case 44:
#line 413 "DssParser.y"
{ yyvsp[-4].yPointList[0].push_back(yyvsp[-2].yNumber);
                                  yyvsp[-4].yPointList[1].push_back(yyvsp[0].yNumber);
                                  yyval.yPointList = yyvsp[-4].yPointList; }
    break;
case 45:
#line 417 "DssParser.y"
{ std::vector<float> x; x.push_back(yyvsp[-2].yNumber);
                                  std::vector<float> y; y.push_back(yyvsp[0].yNumber);
                                  std::vector<float> *v =
                                        new std::vector<float>[2];
                                  v[0] = x; v[1] = y;
                                  yyval.yPointList = v; }
    break;
case 46:
#line 426 "DssParser.y"
{ yyvsp[-2].yRangeList->push_back(*yyvsp[0].yRange);
                                  delete yyvsp[0].yRange;
                                  yyval.yRangeList = yyvsp[-2].yRangeList;
                                }
    break;
case 47:
#line 430 "DssParser.y"
{ yyval.yRangeList = new DRangeList;
                                  yyval.yRangeList->push_back(*yyvsp[0].yRange);
                                  delete yyvsp[0].yRange;
                                }
    break;
case 48:
#line 436 "DssParser.y"
{ yyval.yNumber = yyvsp[-2].yNumber + yyvsp[0].yNumber; }
    break;
case 49:
#line 437 "DssParser.y"
{ yyval.yNumber = yyvsp[-2].yNumber - yyvsp[0].yNumber; }
    break;
case 50:
#line 438 "DssParser.y"
{ yyval.yNumber = yyvsp[-2].yNumber * yyvsp[0].yNumber; }
    break;
case 51:
#line 439 "DssParser.y"
{ if (yyvsp[0].yNumber == 0.) {
                                      selerrstr<<"Division by 0 in `/' operator."
                                           <<selerror("ArithmeticException");
                                    SELTHROW(DssBuilder::ArithmeticException);
                                  }
                                  yyval.yNumber = yyvsp[-2].yNumber / yyvsp[0].yNumber;
                                }
    break;
case 52:
#line 446 "DssParser.y"
{ if (yyvsp[0].yNumber == 0.) {
                                      selerrstr<<"Division by 0 in `modulo' operator."
                                           <<selerror("ArithmeticException");
                                    SELTHROW(DssBuilder::ArithmeticException);
                                  }
                                  yyval.yNumber = fmod(yyvsp[-2].yNumber, yyvsp[0].yNumber);
                                }
    break;
case 53:
#line 453 "DssParser.y"
{ double dum;
                                  if (yyvsp[-2].yNumber < 0. && modf(yyvsp[0].yNumber, &dum) != 0.) {
                                      selerrstr<<"Cannot raise "<<yyvsp[-2].yNumber<<" to the power "<<yyvsp[0].yNumber<<" ."
                                           <<selerror("ArithmeticException");
                                    SELTHROW(DssBuilder::ArithmeticException);
                                  }
                                  yyval.yNumber = pow(yyvsp[-2].yNumber, yyvsp[0].yNumber);
                                }
    break;
case 54:
#line 461 "DssParser.y"
{ yyval.yNumber = DBL(UNT(yyvsp[-2].yNumber) & UNT(yyvsp[0].yNumber)); }
    break;
case 55:
#line 462 "DssParser.y"
{ yyval.yNumber = DBL(UNT(yyvsp[-2].yNumber) | UNT(yyvsp[0].yNumber)); }
    break;
case 56:
#line 463 "DssParser.y"
{ yyval.yNumber = DBL(UNT(yyvsp[-2].yNumber) ^ UNT(yyvsp[0].yNumber)); }
    break;
case 57:
#line 464 "DssParser.y"
{ yyval.yNumber = DBL(UNT(yyvsp[-2].yNumber) << UNT(yyvsp[0].yNumber)); }
    break;
case 58:
#line 465 "DssParser.y"
{ yyval.yNumber = DBL(UNT(yyvsp[-2].yNumber) >> UNT(yyvsp[0].yNumber)); }
    break;
case 59:
#line 466 "DssParser.y"
{ yyval.yNumber = DBL(~UNT(yyvsp[0].yNumber)); }
    break;
case 60:
#line 467 "DssParser.y"
{ yyval.yNumber = (*yyvsp[-3].yFunc1)(yyvsp[-1].yNumber); }
    break;
case 61:
#line 469 "DssParser.y"
{ yyval.yNumber = (*yyvsp[-5].yFunc2)(yyvsp[-3].yNumber, yyvsp[-1].yNumber); }
    break;
case 62:
#line 470 "DssParser.y"
{ yyval.yNumber = -yyvsp[0].yNumber; }
    break;
case 63:
#line 471 "DssParser.y"
{ yyval.yNumber = yyvsp[-1].yNumber; }
    break;
case 65:
#line 475 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, DBL_MAX,
                                                          Unbounded, Unbounded); }
    break;
case 66:
#line 477 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, DBL_MAX,
                                                          Unbounded, Unbounded); }
    break;
case 67:
#line 479 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, DBL_MAX,
                                                          Unbounded, Unbounded); }
    break;
case 68:
#line 481 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, DBL_MAX,
                                                          Unbounded, Unbounded); }
    break;
case 69:
#line 483 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, DBL_MAX,
                                                          Unbounded, Unbounded); }
    break;
case 70:
#line 485 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[0].yNumber, yyvsp[0].yNumber); }
    break;
case 71:
#line 486 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-1].yNumber, yyvsp[-1].yNumber); }
    break;
case 72:
#line 487 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-1].yNumber, DBL_MAX,
                                                          Closed, Unbounded); }
    break;
case 73:
#line 489 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-2].yNumber, DBL_MAX,
                                                          Closed, Unbounded); }
    break;
case 74:
#line 491 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-2].yNumber, DBL_MAX,
                                                          Closed, Unbounded); }
    break;
case 75:
#line 493 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-2].yNumber, DBL_MAX,
                                                          Open, Unbounded); }
    break;
case 76:
#line 495 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-2].yNumber, DBL_MAX,
                                                          Open, Unbounded); }
    break;
case 77:
#line 497 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, yyvsp[0].yNumber,
                                                          Unbounded, Closed); }
    break;
case 78:
#line 499 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, yyvsp[-1].yNumber,
                                                          Unbounded, Closed); }
    break;
case 79:
#line 501 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, yyvsp[-1].yNumber,
                                                          Unbounded, Open); }
    break;
case 80:
#line 503 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, yyvsp[-1].yNumber,
                                                          Unbounded, Closed); }
    break;
case 81:
#line 505 "DssParser.y"
{ yyval.yRange = new DRange(-DBL_MAX, yyvsp[-1].yNumber,
                                                          Unbounded, Open); }
    break;
case 82:
#line 507 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-2].yNumber, yyvsp[0].yNumber); }
    break;
case 83:
#line 508 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-3].yNumber, yyvsp[-1].yNumber); }
    break;
case 84:
#line 509 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-3].yNumber, yyvsp[-1].yNumber,
                                                          Open, Closed); }
    break;
case 85:
#line 511 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-3].yNumber, yyvsp[-1].yNumber,
                                                          Closed, Open); }
    break;
case 86:
#line 513 "DssParser.y"
{ yyval.yRange = new DRange(yyvsp[-3].yNumber, yyvsp[-1].yNumber,
                                                          Open, Open); }
    break;
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 516 "DssParser.y"


}
